<?php
/***************************************************************************
*                             admin_db_utilities.php
*                              -------------------
*     begin                : Thu May 31, 2001
*     copyright            : (C) 2001 The phpBB Group
*     email                : support@phpbb.com
*


 	File: $Id: blocks.php,v 1.1.2.22 2007/03/18 14:33:36 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005,
	Author: surgeon <sursoft@nm.ru> http://skillz.ru

*
****************************************************************************/



if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['General']['Backup_DB'] = $filename . "?perform=backup";

	$file_uploads = (@phpversion() >= '4.0.0') ? @ini_get('file_uploads') : @get_cfg_var('file_uploads');

	return;
}

define('MAIN_LOADED', 1);


//
// Load default header
//
$no_page_header = TRUE;
$root_path = "./../";
require('./pagestart.php');
include($root_path . 'includes/sql_parse.'.$phpEx);

if( empty($setmodules) ) {
   //[FIX] php5 load function twice
   include($root_path . 'admin/includes/function_db.' . $phpEx);
}
//
// Set VERBOSE to 1  for debugging info..
//
define("VERBOSE", 0);

$req_file = $core->request_var('file','');
$req_file = str_replace('..','',$req_file);

//
// Increase maximum execution time, but don't complain about it if it isn't
// allowed.
//
@set_time_limit(1200);

$perform = $core->request_var('perform','backup');

	switch($perform)
	{
		case 'backup':

			$error = false;
			switch(SQL_LAYER)
			{
				case 'oracle':
					$error = true;
					break;
				case 'db2':
					$error = true;
					break;
				case 'msaccess':
					$error = true;
					break;
				case 'mssql':
				case 'mssql-odbc':
					$error = true;
					break;
			}

			if ($error)
			{
				include('./page_header_admin.'.$phpEx);

				$template->set_filenames(array(
					"body" => "admin/admin_message_body.tpl")
				);

				$template->assign_vars(array(
					"MESSAGE_TITLE" => $lang['Information'],
					"MESSAGE_TEXT" => $lang['Backups_not_supported'])
				);

				$template->pparse("body");

				include('./page_footer_admin.'.$phpEx);
			}

			//SUR: enum all tables from db (mysql only).

			$sql = 'SHOW TABLES';
			$core->db->sql_query($sql);
			$tables = array();
			while($row=$core->db->sql_fetchrow()) {
			   list($key,$table)=each($row);
			   $tables[] = $table;
			}

			$backup_type = (isset($HTTP_POST_VARS['backup_type'])) ? $HTTP_POST_VARS['backup_type'] : ( (isset($HTTP_GET_VARS['backup_type'])) ? $HTTP_GET_VARS['backup_type'] : "" );

			$gzipcompress = (!empty($HTTP_POST_VARS['gzipcompress'])) ? $HTTP_POST_VARS['gzipcompress'] : ( (!empty($HTTP_GET_VARS['gzipcompress'])) ? $HTTP_GET_VARS['gzipcompress'] : 0 );

			$drop = (!empty($HTTP_POST_VARS['drop'])) ? intval($HTTP_POST_VARS['drop']) : ( (!empty($HTTP_GET_VARS['drop'])) ? intval($HTTP_GET_VARS['drop']) : 0 );

			if( !isset($HTTP_POST_VARS['backupstart']) && !isset($HTTP_GET_VARS['backupstart']))
			{
				include('./page_header_admin.'.$phpEx);

				$template->set_filenames(array(
					"body" => "admin/db_utils_backup_body.tpl")
				);
				$s_hidden_fields = "<input type=\"hidden\" name=\"perform\" value=\"backup\" /><input type=\"hidden\" name=\"drop\" value=\"1\" /><input type=\"hidden\" name=\"perform\" value=\"$perform\" />";

				$template->assign_vars(array(
					"L_DATABASE_BACKUP" => $lang['Database_Utilities'] . " : " . $lang['Backup'],
					"L_BACKUP_EXPLAIN" => $lang['Backup_explain'],
					"L_FULL_BACKUP" => $lang['Full_backup'],
					"L_STRUCTURE_BACKUP" => $lang['Structure_backup'],
					"L_DATA_BACKUP" => $lang['Data_backup'],
					"L_ADDITIONAL_TABLES" => $lang['Additional_tables'],
					"L_START_BACKUP" => $lang['Start_backup'],
					"L_BACKUP_OPTIONS" => $lang['Backup_options'],
					"L_GZIP_COMPRESS" => $lang['Gzip_compress'],
					"L_NO" => $lang['No'],
					"L_YES" => $lang['Yes'],

					"S_HIDDEN_FIELDS" => $s_hidden_fields,
					"S_DBUTILS_ACTION" => append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx"))
				);

                // import vars

                $s_hidden_fields = "<input type=\"hidden\" name=\"perform\" value=\"restore\" /><input type=\"hidden\" name=\"perform\" value=\"$perform\" />";

				$template->assign_vars(array(
					"L_DATABASE_RESTORE" => $lang['Database_Utilities'] . " : " . $lang['Restore'],
					"L_RESTORE_EXPLAIN" => $lang['Restore_explain'],
					"L_SELECT_FILE" => $lang['Select_file'],
					"L_START_RESTORE" => $lang['Start_Restore'],
					"S_HIDDEN_FIELDS_" => $s_hidden_fields)
				);

                // check for backups

                $b_dir = $GLOBALS['core']->get_cfg_var('site_path') . DB_BACKUP_PATH;

                if (is_dir($b_dir)) {
                    if ($dh = opendir($b_dir)) {
                        while (($file = readdir($dh)) !== false ) {
                        if (preg_match('/(sql|gz)$/',$file)) {
                            $core->template->assign_block_vars("DB_FILES",array(
                                'file' =>urlencode($file),
                                'url'  => append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx") . "&perform=restore&file=".urlencode($file),
                                'dl_url'  => append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx") . "&perform=dl&file=".urlencode($file),
                                'drop_url'  => append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx") . "&perform=dl_drop&file=".urlencode($file)
                                ));
                            }
                        }
                        closedir($dh);
                    }
                }


				$template->pparse("body");

				break;

			}
			else if( !isset($HTTP_POST_VARS['startdownload']) && !isset($HTTP_GET_VARS['startdownload']) )
			{

				$template->set_filenames(array(
					"body" => "admin/admin_message_body.tpl")
				);

				$template->assign_vars(array(
					"META" => '<meta http-equiv="refresh" content="2;url=' . append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx?perform=backup&backup_type=$backup_type&drop=1&amp;backupstart=1&gzipcompress=$gzipcompress&startdownload=1") . '">',

					"MESSAGE_TITLE" => $lang['Database_Utilities'] . " : " . $lang['Backup'],
					"MESSAGE_TEXT" => $lang['Backup_download'])
				);

				include('./page_header_admin.'.$phpEx);

				$template->pparse("body");

				include('./page_footer_admin.'.$phpEx);

			}
			header("Pragma: no-cache");
			$do_gzip_compress = FALSE;
			if( $gzipcompress )
			{
				$phpver = phpversion();

				if($phpver >= "4.0")
				{
					if(extension_loaded("zlib"))
					{
						$do_gzip_compress = TRUE;
					}
				}
			}

            $backup_name_ = str_replace('.','_',$dbname) . '-' . date('Y_m_d-H_i') . '.sql';

			if($do_gzip_compress)
			{
				header("Content-Type: application/x-gzip; name=\"{$backup_name_}.gz\"");
				header("Content-disposition: attachment; filename={$backup_name_}.gz");
			}
			else
			{
				header("Content-Type: text/x-delimtext; name=\"{$backup_name_}\"");
				header("Content-disposition: attachment; filename={$backup_name_}");
			}

           	@ob_start();
			@ob_implicit_flush(0);

			//
			// Build the sql script file...
			//
			echo "#\n";
			echo "# Skill-Z Backup Script\n";
			echo "# Dump of tables for $dbname\n";
			echo "#\n# DATE : " .  gmdate("d-m-Y H:i:s", time()) . " GMT\n";
			echo "#\n";

			if(SQL_LAYER == 'postgresql')
			{
				 echo "\n" . pg_get_sequences("\n", $backup_type);
			}

			for($i = 0; $i < count($tables); $i++)
			{
				$table_name = $tables[$i];

				switch (SQL_LAYER)
				{
					case 'postgresql':
						$table_def_function = "get_table_def_postgresql";
						$table_content_function = "get_table_content_postgresql";
						break;

					case 'mysql':
					case 'mysql4':
						$table_def_function = "get_table_def_mysql";
						$table_content_function = "get_table_content_mysql";
						break;
				}

				if($backup_type != 'data')
				{
					echo "#\n# TABLE: " . $table_name . "\n#\n";
				 	echo $table_def_function( $table_name, "\n") . "\n";
				}

				if($backup_type != 'structure')
				{
					$table_content_function( $table_name, "output_table_content");
				}
			}

            $Size = ob_get_length();
			$contents = ob_get_contents();
			ob_end_clean();

            /*  save file
            */

            $save_to = $GLOBALS['core']->get_cfg_var('site_path') . DB_BACKUP_PATH . "{$backup_name_}";

            if($do_gzip_compress) {
                $zp = @gzopen($save_to.'.gz', "w9");
                if ($zp) {
                    gzwrite($zp, $contents);
                    gzclose($zp);
                }
            }
            else {
                    $zp = fopen($save_to, "w");
                    fwrite($zp, $contents);
                    fclose($zp);
                }


            /* finally
            */

			if($do_gzip_compress)
			{
				$Crc = crc32($contents);
				$contents = gzcompress($contents);
				echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr($contents, 0, strlen($contents) - 4).gzip_PrintFourChars($Crc).gzip_PrintFourChars($Size);
			}
            else {
                echo $contents;
            }
			exit;

			break;

/*
    download
*/

        case 'dl':
            header("Content-Type: x-force-download; name=\"{$req_file}\"");
			header("Content-disposition: attachment; filename={$req_file}");
            $b_file = $GLOBALS['core']->get_cfg_var('site_path') . DB_BACKUP_PATH . $req_file;
            echo (file_get_contents($b_file));
            exit;
            break;

/*
    drop
*/

        case 'dl_drop':
            $b_file = $GLOBALS['core']->get_cfg_var('site_path') . DB_BACKUP_PATH . $req_file;
            unlink($b_file);
            redirect( append_sid($core->DIR_ADMIN ."admin_db_utilities.$phpEx")) ;
            break;


		case 'restore':

            // restore from file hack
            if (!empty($req_file)) {
                $b_dir = $GLOBALS['core']->get_cfg_var('site_path') . DB_BACKUP_PATH;
                $HTTP_POST_VARS['restore_start'] = '1';
                $HTTP_POST_FILES['backup_file']=array();
                $HTTP_POST_FILES['backup_file']['tmp_name'] = $b_dir . $req_file;
                $HTTP_POST_FILES['backup_file']['name'] = $req_file;
                $HTTP_POST_FILES['backup_file']['type']='application/octet-stream';
            }

			if(!isset($HTTP_POST_VARS['restore_start']))
			{
				//
				// Define Template files...
				//
				include('./page_header_admin.'.$phpEx);

				$template->pparse("body");

				break;

			}
			else
			{

				//
				// Handle the file upload ....
				// If no file was uploaded report an error...
				//
				$backup_file_name = (!empty($HTTP_POST_FILES['backup_file']['name'])) ? $HTTP_POST_FILES['backup_file']['name'] : "";
				$backup_file_tmpname = ($HTTP_POST_FILES['backup_file']['tmp_name'] != "none") ? $HTTP_POST_FILES['backup_file']['tmp_name'] : "";
				$backup_file_type = (!empty($HTTP_POST_FILES['backup_file']['type'])) ? $HTTP_POST_FILES['backup_file']['type'] : "";

				if($backup_file_tmpname == "" || $backup_file_name == "")
				{
					message_die(GENERAL_MESSAGE, $lang['Restore_Error_no_file']);
				}

				//
				// If I file was actually uploaded, check to make sure that we
				// are actually passed the name of an uploaded file, and not
				// a hackers attempt at getting us to process a local system
				// file.
				//
				if( file_exists(ss_realpath($backup_file_tmpname)) )
				{
					if( preg_match("/^(text\/[a-zA-Z]+)|(application\/(x\-)?gzip(\-compressed)?)|(application\/octet-stream)$/is", $backup_file_type) )
					{
						if( preg_match("/\.gz$/is",$backup_file_name) )
						{
							$do_gzip_compress = FALSE;
							$phpver = phpversion();
							if($phpver >= "4.0")
							{
								if(extension_loaded("zlib"))
								{
									$do_gzip_compress = TRUE;
								}
							}

							if($do_gzip_compress)
							{
								$gz_ptr = gzopen($backup_file_tmpname, 'rb');
								$sql_query = "";
								while( !gzeof($gz_ptr) )
								{
									$sql_query .= gzgets($gz_ptr, 100000);
								}
							}
							else
							{
								message_die(GENERAL_ERROR, $lang['Restore_Error_decompress']);
							}
						}
						else
						{

							$sql_query = fread(fopen($backup_file_tmpname, 'r'), filesize($backup_file_tmpname));
						}
						//
						// Comment this line out to see if this fixes the stuff...
						//
						//$sql_query = stripslashes($sql_query);
					}
					else
					{
                		message_die(GENERAL_ERROR, $lang['Restore_Error_filename'] ." $backup_file_type $backup_file_name");
					}
				}
				else
				{
					message_die(GENERAL_ERROR, $lang['Restore_Error_uploading']);
				}

				if($sql_query != "")
				{
					// Strip out sql comments...
					$sql_query = remove_remarks($sql_query);
					$pieces = split_sql_file($sql_query, ";");

					$sql_count = count($pieces);
					for($i = 0; $i < $sql_count; $i++)
					{
						$sql = trim($pieces[$i]);

						if(!empty($sql) and $sql[0] != "#")
						{
							if(VERBOSE == 1)
							{
								echo "Executing: $sql\n<br>";
								flush();
							}

							$result = $db->sql_query($sql);

							if(!$result && ( !(SQL_LAYER == 'postgresql' && eregi("drop table", $sql) ) ) )
							{
								message_die(GENERAL_ERROR, "Error importing backup file", "", __LINE__, __FILE__, $sql);
							}
						}
					}
				}

				include('./page_header_admin.'.$phpEx);

				$template->set_filenames(array(
					"body" => "admin/admin_message_body.tpl")
				);

				$message = $lang['Restore_success'];

				$template->assign_vars(array(
					"MESSAGE_TITLE" => $lang['Database_Utilities'] . " : " . $lang['Restore'],
					"MESSAGE_TEXT" => $message)
				);

				$template->pparse("body");
				break;
			}
			break;
	}


include('./page_footer_admin.'.$phpEx);

?>
