<?php

/*
 	File: $Id: blocks.php,v 1.1.2.22 2007/03/18 14:33:36 surg30n Exp $
	Project: Skill-Z project, SurSoft (C) 2005,
	Author: surgeon <sursoft@nm.ru> http://skillz.ru
	ADMIN DB FUNCTIONs
*/

define('DB_BACKUP_PATH', 'admin/backups/');

// -----------------------
// The following functions are adapted from phpMyAdmin and upgrade_20.php
//
function gzip_PrintFourChars($Val)
{
    $return = '';
	for ($i = 0; $i < 4; $i ++)
	{
		$return .= chr($Val % 256);
		$Val = floor($Val / 256);
	}
	return $return;
}



//
// This function returns the "CREATE TABLE" syntax for mysql dbms...
//

function get_table_def_mysql($table, $crlf)
{
	global /*$drop,*/ $db, $dbname;

    $drop = 1;

	$index = array();
	$schema_create = "";
	$field_query = "SHOW FIELDS FROM $table";
	$key_query = "SHOW KEYS FROM $table";

	//
	// If the user has selected to drop existing tables when doing a restore.
	// Then we add the statement to drop the tables....
	//
	if ($drop == 1)
	{
		$schema_create .= "DROP TABLE IF EXISTS $table;$crlf";
	}

	# $schema_create .= "CREATE TABLE $table($crlf";

    $sql = "SHOW CREATE TABLE {$table}";
    $result_t = $db->sql_query($sql);
    $tmpres = $db->sql_fetchrow($result_t);

    /*
   array(2) {
   ["Table"]=>
   string(13) "_vote_results"
   ["Create Table"]=>
   string(274) "CREATE TABLE `_vote_results` (
    `user_ip` varchar(8) default NULL,
     KEY `vote_id` (`vote_id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=cp1251"
   }
    */

    $schema_create .= $tmpres["Create Table"];

    // leeched from phpmyadmin (save AUTOINCREMENT field)

    $auto_increment = '';
    $sql = 'SHOW TABLE STATUS FROM ' . $dbname . ' LIKE \'' . ($table) . '\'';
    $result_t = $db->sql_query($sql);
    if ($result_t) {
        if ($db->sql_numrows($result_t) > 0) {
            $tmpres = $db->sql_fetchrow($result_t);
            if (!empty($tmpres['Auto_increment'])) {
                $auto_increment .= ' AUTO_INCREMENT=' . $tmpres['Auto_increment'] . ' ';
            }
       }
    }

	$schema_create .= " {$auto_increment}; {$crlf}"; //SUR: type myisam (work only in mysql4)

	if(get_magic_quotes_runtime())
	{
		return(stripslashes($schema_create));
	}
	else
	{
		return($schema_create);
	}

} // End get_table_def_mysql


//
// This fuction will return a tables create definition to be used as an sql
// statement.
//
//
// The following functions Get the data from the tables and format it as a
// series of INSERT statements, for each different DBMS...
// After every row a custom callback function $handler gets called.
// $handler must accept one parameter ($sql_insert);
//
//
// This function is for getting the data from a mysql table.
//

function get_table_content_mysql($table, $handler)
{
	global $db;

	// Grab the data from the table.
	if (!($result = $db->sql_query("SELECT * FROM $table")))
	{
		message_die(GENERAL_ERROR, "Failed in get_table_content (select *)", "", __LINE__, __FILE__, "SELECT * FROM $table");
	}

	// Loop through the resulting rows and build the sql statement.
	if ($row = $db->sql_fetchrow($result))
	{
		$handler("\n#\n# Table Data for $table\n#\n");
		$field_names = array();

		// Grab the list of field names.
		$num_fields = $db->sql_numfields($result);
		$table_list = '(';
		for ($j = 0; $j < $num_fields; $j++)
		{
			$field_names[$j] = $db->sql_fieldname($j, $result);
			$table_list .= (($j > 0) ? ', ' : '') . $field_names[$j];

		}
		$table_list .= ')';

		do
		{
			// Start building the SQL statement.
			$schema_insert = "INSERT INTO $table $table_list VALUES(";

			// Loop through the rows and fill in data for each column
			for ($j = 0; $j < $num_fields; $j++)
			{
				$schema_insert .= ($j > 0) ? ', ' : '';

				if(!isset($row[$field_names[$j]]))
				{
					//
					// If there is no data for the column set it to null.
					// There was a problem here with an extra space causing the
					// sql file not to reimport if the last column was null in
					// any table.  Should be fixed now :) JLH
					//
					$schema_insert .= 'NULL';
				}
				elseif ($row[$field_names[$j]] != '')
				{
					$schema_insert .= '\'' . addslashes($row[$field_names[$j]]) . '\'';
				}
				else
				{
					$schema_insert .= '\'\'';
				}
			}

			$schema_insert .= ');';

			// Go ahead and send the insert statement to the handler function.
			$handler(trim($schema_insert));

		}
		while ($row = $db->sql_fetchrow($result));
	}

	return(true);
}

function output_table_content($content)
{
	global $tempfile;

	//fwrite($tempfile, $content . "\n");
	//$backup_sql .= $content . "\n";
	echo $content ."\n";
	return;
}
//
// End Functions
// -------------

?>
